#include maps\mp\_utility; //<-- multiplayer utility script

main()
{
	maps\mp\mp_strenan_fx::main();
	maps\mp\_breakwindow::window_think();
	maps\mp\_load::main();

	setExpFog(0.0001, 0.6, 0.7, 0.6, 0);
	ambientPlay("ambient_mp_strenan");

	game["allies"] = "american";
	game["axis"] = "german";
	game["defenders"] = "allies";
	game["attackers"] = "axis";	
	game["american_soldiertype"] = "normandy";
	game["german_soldiertype"] = "normandy";

	setCvar("r_glowbloomintensity0", ".25");
	setCvar("r_glowbloomintensity1", ".25");
	setcvar("r_glowskybleedintensity0",".25");

	level thread bridge_blow();
	thread exploding_barrels();
	thread breakable_wood();
	rotate_doors_init();

}


////////////////////////////////////////////////////////////////////////////////
// DOORS
////////////////////////////////////////////////////////////////////////////////


rotation_dir(door, other)
{
door_origin_x = door.origin[0];
door_origin_y = door.origin[1];
player_origin_x = other.origin[0];
player_origin_y = other.origin[1];
orient = int(door.script_noteworthy);
rotatedir = -90;

//This next group is hard-coded for a player radius shift based on orientation of the door. Needs altering to suit angled doors too.
if (orient == 0)
player_origin_y -= 50;
else if (orient == 180)
player_origin_y += 50;
else if (orient == 90)
player_origin_x -= 50;
else if (orient == 270)
player_origin_x += 50;

if ( ((orient == 0) && (player_origin_x < door_origin_x ) && (player_origin_y < door_origin_y)) ||
	((orient == 90) && (player_origin_x < door_origin_x ) && (player_origin_y > door_origin_y)) ||
	((orient == 180) && (player_origin_x > door_origin_x ) && (player_origin_y > door_origin_y)) ||
	((orient == 270) && (player_origin_x > door_origin_x ) && (player_origin_y < door_origin_y)) )

rotatedir = 90;

return rotatedir;
}




rotate_doors_init()
{
doortrigs = getentarray("door_trigger", "targetname");

for(i=0; i <doortrigs.size; i++)
{
door = getent(doortrigs[i].target, "targetname");
doortrigs thread rotate_doors(doortrigs[i], door);
}
}




rotate_doors(trig, door)
{
if(isdefined(door))
{
while (1)
	{
	trig waittill("trigger", other);
	rotatedir = thread rotation_dir(door, other);
	door rotateYaw(rotatedir, 1.5, 0.7, 0.7);
	door playsound ("wood_door_open");
	door waittill("rotatedone");
	wait (2);
	while (isalive (other) && (other istouching (trig)))
	wait (1);
	wait (2);
	door rotateto ((0,0,0),1.5, 0.75, 0.75);
	door playsound ("wood_door_move");
	door waittill("rotatedone");
	door playsound ("wood_door_close_stop");
	}
}
}


/////////////////////////////////////////////////////////////
// BREAKBLE WOOD
/////////////////////////////////////////////////////////////

breakable_wood()
{
	wood_blocks = getentarray("wood","targetname"); //find everything with targetname "wood"
	if(isdefined(wood_blocks))
	{
		woodbreak = loadfx("fx/impacts/large_woodhit.efx");

		for(i=0;i<wood_blocks.size;i++) //start threads listening for all wood triggers
		{
			wood_blocks[i] thread wood();
		}
	}
	//end breaking windows main
}

wood()
{
	wood = getent(self.target,"targetname");
level.max_hits = 3; //Maximum number of hits/bashes wood can take before breaking.
no_of_hits = 0;

    while(1) //Thread hangs here waiting for sufficient damage on the trigger
    {
        self waittill ("damage",amount);
        self playsound ("renan_woodbreak1");
//       iprintlnbold("Wood damage = ", amount); // <--- Add this line for debug.
        no_of_hits += 1; //wood accumulates damage
//        iprintlnbold("Hits so far = ", no_of_hits); // <--- Add this line for debug.
        if(no_of_hits > level.max_hits) //The trigger has been set off
		{
		self notify("trigger");
		self playsound ("renan_woodbreak2");	
		self delete(); //remove trigger		
		}
	}
}



/////////////////////////////////////////////////////////////
// BARRELS
/////////////////////////////////////////////////////////////


exploding_barrels()
{
	level._effect["barrel_explode"] = loadfx ("fx/props/barrelExp.efx");
	level._effect["barrel_burn_start"] = loadfx ("fx/props/barrel_ignite.efx");
	level._effect["barrel_burn"] = loadfx ("fx/fire/building_fire_large.efx"); // or use ("fx/props/barrel_fire.efx")

	dtrig = getentarray ("barrel_trigger","targetname");
	for (t=0; t<dtrig.size; t++) dtrig[t] thread barrel_think();
}

barrel_think()
{
	self waittill ("trigger");
	//iprintln("barrel triggered");

	barrel = getentarray(self.target,"targetname");
	for (b=0; b<barrel.size; b++) barrel[b] thread barrel_exploded();

	wait.5;

	self delete();
}

barrel_exploded()
{
	clip = getent(self.target, "targetname");

	playfx (level._effect["barrel_burn_start"],self.origin);
	wait .5;
	playfx (level._effect["barrel_burn"], ((self.origin) + (0,0,15)));

	wait randomint((1) + 1);

	self playsound ("explo_metal_rand");
	playfx (level._effect["barrel_explode"], ((self.origin) + (0,0,45)));

	radiusDamage (self.origin + (0,0,56), 500, 150, 20);
	//(vec origin, float range, float max_damage, float min_damage)

	earthquake(0.3, 3, self.origin, 850);
	//(scale, duration, source, radius)

	wait .25;

	self delete();
	clip delete();
}


bridge_blow()
{
for(;;)
{
level endon("intermission");
level endon("round_ended");

self waittill ("bomb_planted");
wait (level.bombtimer);
earthquake(0.3, 3, (-827, 319, -88), 2500);
}
}
